
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Sphere( radius, center, depth, clockwise, primitive )
float radius;
Point center;
int depth;
char clockwise;
int primitive;
{
    int i, j;        /* i/phi    j/theta */
    float is, js;
    float phi, theta, step;
    float fphiSize, fthetaSize;
    int phiSize, thetaSize;
    Point sphere[130][260];
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    step = (float)(M_PI / pow( (double)2, (double)depth ));
    fphiSize = (M_PI / step) + 1.;
    fthetaSize = (2 * M_PI / step) + 1.;
    phiSize = (int)fphiSize;
    thetaSize = (int)fthetaSize;
#if( 0 ) 
    /* Initialize the North pole */
    for( j = 0; j < thetaSize; j++ ) {
        sphere[0][j].x =     0. + center.x;
        sphere[0][j].y = radius + center.y;
        sphere[0][j].z =     0. + center.z;
    }
    /* Copy one more point which is the same as the first */
    sphere[0][j].x =     0. + center.x;
    sphere[0][j].y = radius + center.y;
    sphere[0][j].z =     0. + center.z;

    /* Initialize the South pole */
    for( j = 0; j < thetaSize; j++ ) {
        sphere[phiSize-1][j].x =      0. + center.x;
        sphere[phiSize-1][j].y = -radius + center.y;
        sphere[phiSize-1][j].z =      0. + center.z;
    }
    /* Copy one more point which is the same as the first */
    sphere[phiSize-1][j].x =      0. + center.x;
    sphere[phiSize-1][j].y = -radius + center.y;
    sphere[phiSize-1][j].z =      0. + center.z;

    for( i = 0 + 1; i < phiSize-1; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
#endif		/*  */

    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            is = i * step;   js = j * step;
            sphere[i][j].x = radius * sin( is ) * cos( js ) + center.x;
            sphere[i][j].y = radius * cos( is )             + center.y;
            sphere[i][j].z = radius * sin( is ) * sin( js ) + center.z;
        }
    }
#if( 0 ) 
    fprintf( fp, "%d\t%d\t%d\n", phiSize * thetaSize, (phiSize-1) * (thetaSize-1), 4 * (phiSize-1) * (thetaSize-1) );
#endif		/*  */
    fprintf( fp, "%d\t%d\t%d\n", phiSize * thetaSize, 2 * (phiSize-1) * (thetaSize-1), 6 * (phiSize-1) * (thetaSize-1) );

    /* Print the Coordinates of the points */
    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            fprintf( fp, "%f %f %f\n", sphere[i][j].x, sphere[i][j].y,
                                  sphere[i][j].z );
        }
    }

    /* Print the Conectivity data of the points */
    if( !clockwise ) {    /* counterClockwise */
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
#if( 0 ) 
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1,         j*thetaSize+(i+1)+1,
                       (j+1)*thetaSize+(i+1)+1, (j+1)*thetaSize+i+1 );
#endif		/*  */
                fprintf( fp, "3 %d %d %d\n",
                           j*thetaSize+i+1,         j*thetaSize+(i+1)+1,
                       (j+1)*thetaSize+(i+1)+1 );
                fprintf( fp, "3 %d %d %d\n",
                       (j+1)*thetaSize+(i+1)+1, (j+1)*thetaSize+i+1,
                           j*thetaSize+i+1 );
            }
        }
    }
    else {
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1, (j+1)*thetaSize+i+1,
                   (j+1)*thetaSize+(i+1)+1, j*thetaSize+(i+1)+1 );
            }
        }
    }
    fclose( fp );
}
